//RaspberryPIpȈՃIVXR[vvO

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <usb.h>
#include <GLES2/gl2.h>
#include <EGL/egl.h>

/*
#include <wiringPi.h>
#include <wiringPiSPI.h>
#define chksig0 0 // GPIO 0
#define chksig1 1 // GPIO 1
#define chksig2 2 // GPIO 2
#define chksig3 3 // GPIO 3
#define chksig4 4 // GPIO 4
#define chksig5 5 // GPIO 5
#define chksig6	6 // GPIO 6
*/

#define LinePoint 50	//ڐpC̃|Cg
#define PixNum_X 1000	//FullHD1920fۂ܂ŕKvƂȂ낤Ƃ肠1000fƂ
#define AD_SCALE 512	//A/D10bitŁA}512ƂȂ鎖
#define X_SCALE 0.9		//g``g̑Ŝ̏k-Xp
#define Y_SCALE 0.9		//g``g̑Ŝ̏k-Yp
#define FByte 8192		//1usb_bulk_read߂ɂĎ擾f[^
#define DataNum FByte/2	//擾f[^8192oCg=4096[hA1̓]f[^ɂ4096̃f[^

#define USB_VENDOR 0x04B4	//TCvXFX2̃ftHg
#define USB_PRODUCT 0x8613	//TCvXFX2̃ftHg
#define TIMEOUT (5*1000)
#define EP6	0x86

void* thread1(void* pParam); //XbhP
void* thread2(void* pParam); //XbhQ

volatile int area = 0;		//ȉXbhԂŎgϐvolatileĂ
volatile int view_act = 0;
volatile long time_us,time_x,avg_num;
volatile int pix_x;
volatile int s_clk;
volatile int trg_e;
volatile int delta_org;//gKɂrf[^̎ԍ
volatile signed short T_Level,O_Level,T_Pos;
volatile float Gain;
volatile unsigned char buf[3][FByte];//USBf[^擾pobt@ƂĎg

pthread_mutex_t mutex; //2̃XbhԂŕϐ̕یsɎgi񑊌݂ŕύXϐ͖̂Ŗgpj

typedef struct {
  EGLNativeWindowType  nativeWin;
  EGLDisplay  display;
  EGLContext  context;
  EGLSurface  surface;
  EGLint	  majorVersion;
  EGLint	  minorVersion;
  int		  width;
  int		  height;
} ScreenSettings;

const char vShaderSrc[] =
  "attribute vec3  aPosition;\n"
  "attribute vec2  aTex;     \n"
  "varying   vec2  vTex;\n"
  "uniform   float uFrame;\n"
  "void main()        \n"
  "{                  \n"
  "  vTex = aTex;     \n"
  "  gl_Position = vec4(aPosition.x - uFrame, aPosition.y + uFrame, 0, 1);\n"
  "}                  \n";

const char fShaderSrc[] =
  "precision mediump float;\n"\
  "varying   vec2  vTex;\n"
  "void main()        \n"
  "{                  \n"
  "  gl_FragColor = vec4(vTex.y, vTex.x, 0.5, 0.5);\n"
  "}                  \n";

typedef struct {
  GLint   aPosition;
  GLint   aTex;
  GLint   uFrame;
} ShaderParams;

typedef struct {
	GLfloat x, y, z;
	GLfloat u, v;
} VertexType;

VertexType vObj[PixNum_X]; 		//_f[^
VertexType lObj[LinePoint]; 	//LINEf[^

unsigned short ivObj[PixNum_X] ;	//_pCfbNXf[^
unsigned short ilObj[LinePoint];	//LINEpCfbNXf[^

ShaderParams	g_sp;
ScreenSettings	g_sc;

GLuint g_vbo;		//_p
GLuint g_ivbo;		//CfbNXp
GLuint g_lbo;		//LINEp
GLuint g_ilbo;		//CfbNXp
GLuint g_program;


/* Init USB */
struct usb_bus *USB_init()
{
	usb_init();
	usb_find_busses();
	usb_find_devices();
	return(usb_get_busses());
}

/* Find USB device	*/
struct usb_device *USB_find(struct usb_bus *busses, struct usb_device *dev)
{
	struct usb_bus *bus;
	for(bus=busses; bus; bus=bus->next){
		for(dev=bus->devices; dev; dev=dev->next) {
			if( (dev->descriptor.idVendor==USB_VENDOR) && (dev->descriptor.idProduct==USB_PRODUCT) ){
				return( dev );
			}
		}
	}
	return( NULL );
}
/* USB Open */
struct usb_dev_handle *USB_open(struct usb_device *dev)
{
	struct usb_dev_handle *udev = NULL;

	udev=usb_open(dev);
	if( (udev=usb_open(dev))==NULL ){
		fprintf(stderr,"usb_open Error.(%s)\n",usb_strerror());
		exit(1);
	}

	if( usb_set_configuration(udev,dev->config->bConfigurationValue)<0 ){
		if( usb_detach_kernel_driver_np(udev,dev->config->interface->altsetting->bInterfaceNumber)<0 ){
			fprintf(stderr,"usb_set_configuration Error.\n");
			fprintf(stderr,"usb_detach_kernel_driver_np Error.(%s)\n",usb_strerror());
 		}
	}

	if( usb_claim_interface(udev,dev->config->interface->altsetting->bInterfaceNumber)<0 ){
		if( usb_detach_kernel_driver_np(udev,dev->config->interface->altsetting->bInterfaceNumber)<0 ){
			fprintf(stderr,"usb_claim_interface Error.\n");
			fprintf(stderr,"usb_detach_kernel_driver_np Error.(%s)\n",usb_strerror());
		}
	}

	if( usb_claim_interface(udev,dev->config->interface->altsetting->bInterfaceNumber)<0 ){
		fprintf(stderr,"usb_claim_interface Error.(%s)\n",usb_strerror());
	}

	return(udev);
}

/* USB Close */
void USB_close(struct usb_dev_handle *dh)
{
	if(usb_release_interface(dh, 0)){
		fprintf(stderr,"usb_release_interface() failed. (%s)\n",usb_strerror());
		usb_close(dh);
	}
	if( usb_close(dh)<0 ){
		fprintf(stderr,"usb_close Error.(%s)\n",usb_strerror());
	}
}

/* USB altinterface */
void USB_altinterface(struct usb_dev_handle *dh,int tyep)
{
	if(usb_set_altinterface(dh,tyep)<0)
	{
		fprintf(stderr,"Failed to set altinterface %d: %s\n", 1,usb_strerror());
		USB_close(dh);
	}
}

EGLBoolean WinCreate(ScreenSettings *sc)
{
	uint32_t success = 0;
	uint32_t width;
	uint32_t height;
	VC_RECT_T dst_rect;
	VC_RECT_T src_rect;
	DISPMANX_ELEMENT_HANDLE_T dispman_element;
	DISPMANX_DISPLAY_HANDLE_T dispman_display;
	DISPMANX_UPDATE_HANDLE_T dispman_update;
	static EGL_DISPMANX_WINDOW_T nativewindow;
	VC_DISPMANX_ALPHA_T alpha = {DISPMANX_FLAGS_ALPHA_FIXED_ALL_PIXELS, 255, 0};

	success = graphics_get_display_size(0, &width, &height);
	if (success < 0) return EGL_FALSE;

	sc->width = width;
	sc->height = height;

	vc_dispmanx_rect_set(&dst_rect, 0, 0, sc->width, sc->height);
	vc_dispmanx_rect_set(&src_rect, 0, 0, sc->width << 16, sc->height << 16);

	dispman_display = vc_dispmanx_display_open(0);
	dispman_update = vc_dispmanx_update_start(0);
	dispman_element = vc_dispmanx_element_add(dispman_update, dispman_display,
			 0, &dst_rect, 0, &src_rect, DISPMANX_PROTECTION_NONE, &alpha, 0, 0);
	vc_dispmanx_update_submit_sync(dispman_update);
	nativewindow.element = dispman_element;
	nativewindow.width = width;
	nativewindow.height = height;
	sc->nativeWin = &nativewindow;
	return EGL_TRUE;
}

EGLBoolean SurfaceCreate(ScreenSettings *sc)
{
	EGLint attrib[] = {
		EGL_RED_SIZE,		8,
		EGL_GREEN_SIZE, 	8,
		EGL_BLUE_SIZE,		8,
		EGL_ALPHA_SIZE, 	8,
		EGL_DEPTH_SIZE, 	24,
		EGL_NONE
	};
	EGLint context[] = {EGL_CONTEXT_CLIENT_VERSION, 2, EGL_NONE};
	EGLint numConfigs;
	EGLConfig config;

	sc->display = eglGetDisplay(EGL_DEFAULT_DISPLAY);
	if (sc->display == EGL_NO_DISPLAY) return EGL_FALSE;
	if (!eglInitialize(sc->display, &sc->majorVersion, &sc->minorVersion))return EGL_FALSE;
	if (!eglChooseConfig(sc->display, attrib, &config, 1, &numConfigs))return EGL_FALSE;
	sc->surface = eglCreateWindowSurface(sc->display, config, sc->nativeWin, NULL);
	if (sc->surface == EGL_NO_SURFACE) return EGL_FALSE;
	sc->context = eglCreateContext(sc->display, config, EGL_NO_CONTEXT, context);
	if (sc->context == EGL_NO_CONTEXT) return EGL_FALSE;
	if (!eglMakeCurrent(sc->display, sc->surface, sc->surface, sc->context))return EGL_FALSE;
	return EGL_TRUE;
}

GLuint LoadShader(GLenum type, const char *shaderSource)
{
	GLuint shader;
	GLint compiled;

	shader = glCreateShader(type);
	if (shader == 0) return 0;

	glShaderSource(shader, 1, &shaderSource, NULL);
	glCompileShader(shader);

	glGetShaderiv(shader, GL_COMPILE_STATUS, &compiled);
	if (!compiled) { // compile error
		GLint infoLen = 0;
		glGetShaderiv(shader, GL_INFO_LOG_LENGTH, &infoLen);
		if (infoLen > 0) {
			char* infoLog = malloc(sizeof(char) * infoLen);
			glGetShaderInfoLog(shader, infoLen, NULL, infoLog);
			printf("Error compiling shader:\n%s\n", infoLog);
			free(infoLog);
		}
		glDeleteShader(shader);
		return 0;
	}
	return shader;
}

int InitShaders(GLuint *program, char const *vShSrc, char const *fShSrc)
{
	GLuint vShader;
	GLuint fShader;
	GLint  linked;
	GLuint prog;

	vShader = LoadShader(GL_VERTEX_SHADER, vShSrc);
	fShader = LoadShader(GL_FRAGMENT_SHADER, fShSrc);

	prog = glCreateProgram();
	if (prog == 0) return 0;

	glAttachShader(prog, vShader);
	glAttachShader(prog, fShader);
	glLinkProgram(prog);
	glGetProgramiv (prog, GL_LINK_STATUS, &linked);
	if (!linked) { // error
		GLint infoLen = 0;
		glGetProgramiv(prog, GL_INFO_LOG_LENGTH, &infoLen);
		if (infoLen > 0) {
			char* infoLog = malloc(sizeof(char) * infoLen);
			glGetProgramInfoLog(prog, infoLen, NULL, infoLog);
			printf("Error linking program:\n%s\n", infoLog);
			free ( infoLog );
		}
		glDeleteProgram (prog);
		return GL_FALSE;
	}
	glDeleteShader(vShader);
	glDeleteShader(fShader);

	*program = prog;
	return GL_TRUE;
}

void createBuffer(){
	// _Wp̃obt@
	glGenBuffers(1, &g_vbo);  											//obt@̍쐬
	glBindBuffer(GL_ARRAY_BUFFER, g_vbo);								//obt@̎ނݒ
	glBufferData(GL_ARRAY_BUFFER, sizeof(vObj), vObj, GL_STATIC_DRAW);	//GPUɓ]
	// CfbNXp̃obt@
	glGenBuffers(1, &g_ivbo);												//obt@̍쐬
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, g_ivbo);							//obt@̎ނݒ
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(ivObj), ivObj, GL_STATIC_DRAW);//GPUɓ]

	// LINEp̃obt@
	glGenBuffers(1, &g_lbo);  											//obt@̍쐬
	glBindBuffer(GL_ARRAY_BUFFER, g_lbo);								//obt@̎ނݒ
	glBufferData(GL_ARRAY_BUFFER, sizeof(lObj), lObj, GL_STATIC_DRAW);	//GPUɓ]
	// CfbNXp̃obt@
	glGenBuffers(1, &g_ilbo);												//obt@̍쐬
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, g_ilbo);							//obt@̎ނݒ
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(ilObj), ilObj, GL_STATIC_DRAW);//GPUɓ]
}

void Draw (){
	// gpVF[_w
	glUseProgram(g_program);
	// VF[_̃Agr[gϐANZX\ɂ
	glEnableVertexAttribArray(g_sp.aPosition);
	glEnableVertexAttribArray(g_sp.aTex);

	//g`
	// Lɂobt@IuWFNgw
	glBindBuffer(GL_ARRAY_BUFFER, g_lbo);//
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, g_ilbo);//
	// _̃TCYAItZbgw
	glVertexAttribPointer(g_sp.aPosition, 3, GL_FLOAT, GL_FALSE, 20, (void*)0);
	glVertexAttribPointer(g_sp.aTex, 2, GL_FLOAT, GL_FALSE, 20, (void*)12);
	glEnableVertexAttribArray(0);
	//`
	glDrawElements(GL_LINE_STRIP, LinePoint, GL_UNSIGNED_SHORT, 0);

	//g``
	// Lɂobt@IuWFNgw
	glBindBuffer(GL_ARRAY_BUFFER, g_vbo);//
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, g_ivbo);//
	// _̃TCYAItZbgw
	glVertexAttribPointer(g_sp.aPosition, 3, GL_FLOAT, GL_FALSE, 20, (void*)0);
	glVertexAttribPointer(g_sp.aTex, 2, GL_FLOAT, GL_FALSE, 20, (void*)12);
	glEnableVertexAttribArray(0);
	//`
	glDrawElements(GL_LINE_STRIP, pix_x, GL_UNSIGNED_SHORT, 0);
}


int main(int argc, char *argv[]){
	int res;
	int idx;
	int cnum;
	float trg_level,offset_level,trg_pos,v_gain;
	float t_l,o_l,t_p;
	int time_cnum = 0;
	int v_cnum = 0;
	int s_cnum = 0;
	int sampling;

/*
	//GPIOփ`FbNo͂M̐ݒ
	if (wiringPiSetup() == -1)exit(1);
	pinMode(chksig0, OUTPUT);
	pinMode(chksig1, OUTPUT);
	pinMode(chksig2, OUTPUT);
	pinMode(chksig3, OUTPUT);
	pinMode(chksig4, OUTPUT);
	pinMode(chksig5, OUTPUT);
	pinMode(chksig6, OUTPUT);
	if (wiringPiSPISetup (0,4000) == -1)exit(1);
*/

	//̃sNZTvOf[^
	//TvO2MHz
	//10̖ڐŋ؂
	//c8̖ڐŋ؂
	//ItZbgAgKx-10.0`+10.0̊Ԃ̐lŐݒ
	//ȉ̓IvVݒ肪Ȃꍇ̃ftHgl
	time_us = 100;
	trg_level = 0.0;
	trg_e = 1;
	offset_level = 0.0;
	trg_pos = 0.0;
	v_gain = 8.0;
	s_clk = 2;
	delta_org = 1;
	//s̈瓮p[^ݒ肷
	for(cnum=1; cnum<argc; cnum++){
		//Ԏ
		if(strcmp(argv[cnum],"-x1us") == 0)		time_us = 1;	//1div1usɂ
		if(strcmp(argv[cnum],"-x2us") == 0)		time_us = 2;	//1div2usɂ
		if(strcmp(argv[cnum],"-x5us") == 0)		time_us = 5;	//1div5usɂ
		if(strcmp(argv[cnum],"-x10us") == 0)	time_us = 10;	//1div10usɂ
		if(strcmp(argv[cnum],"-x20us") == 0)	time_us = 20;	//1div20usɂ
		if(strcmp(argv[cnum],"-x50us") == 0)	time_us = 50;	//1div50usɂ1000
		if(strcmp(argv[cnum],"-x100us") == 0)	time_us = 100;	//1div100usɂ2000
		if(strcmp(argv[cnum],"-x200us") == 0)	time_us = 200;	//1div200usɂ4000
		if(strcmp(argv[cnum],"-x500us") == 0)	time_us = 500;	//1div500usɂ
		if(strcmp(argv[cnum],"-x1ms") == 0)		time_us = 1000;	//1div1msɂ20000
		if(strcmp(argv[cnum],"-x2ms") == 0)		time_us = 2000;	//1div2msɂ
		if(strcmp(argv[cnum],"-x5ms") == 0)		time_us = 5000;	//1div5msɂ
		if(strcmp(argv[cnum],"-x10ms") == 0)	time_us = 10000;//1div10msɂ
		if(strcmp(argv[cnum],"-x20ms") == 0)	time_us = 20000;//1div20msɂ
		if(strcmp(argv[cnum],"-x50ms") == 0)	time_us = 50000;//1div50msɂ
		if(strcmp(argv[cnum],"-x100ms") == 0)	time_us = 100000;//1div100msɂ
		if(strcmp(argv[cnum],"-x200ms") == 0)	time_us = 200000;//1div200msɂ
		if(strcmp(argv[cnum],"-x500ms") == 0)	time_us = 500000;//1div500msɂ
		if(strcmp(argv[cnum],"-x1s") == 0)		time_us = 1000000;//1div1sɂ
		if(strncmp(argv[cnum],"-x",2) == 0)time_cnum = cnum;
		//d
		if(strcmp(argv[cnum],"-v100mv") == 0)	v_gain = 0.4;	//1div100mvɂ
		if(strcmp(argv[cnum],"-v200mv") == 0)	v_gain = 0.8;	//1div200mvɂ
		if(strcmp(argv[cnum],"-v500mv") == 0)	v_gain = 2.0;	//1div500mvɂ
		if(strcmp(argv[cnum],"-v1v") == 0)		v_gain = 4.0;	//1div1vɂ
		if(strcmp(argv[cnum],"-v2v") == 0)		v_gain = 8.0;	//1div2vɂ
		if(strcmp(argv[cnum],"-v5v") == 0)		v_gain = 20.0;	//1div5vɂ
		if(strncmp(argv[cnum],"-v",2) == 0)v_cnum = cnum;
		//TvONbN
		if(strcmp(argv[cnum],"-s1MHz") == 0)	s_clk = 1;	//TvONbN1MHzɂ
		if(strcmp(argv[cnum],"-s2MHz") == 0)	s_clk = 2;	//TvONbN2MHzɂ
		if(strncmp(argv[cnum],"-s",2) == 0)s_cnum = cnum;
		//gKGbW
		if(strcmp(argv[cnum],"-e0") == 0)		trg_e = 0;//gKGbW𗧂ɂ
		//gKx
		if(strncmp(argv[cnum],"-t",2) == 0)sscanf(argv[cnum]+2,"%f",&trg_level);
		//ItZbg
		if(strncmp(argv[cnum],"-y",2) == 0)sscanf(argv[cnum]+2,"%f",&offset_level);
		//gK|WV
		if(strncmp(argv[cnum],"-p",2) == 0)sscanf(argv[cnum]+2,"%f",&trg_pos);
		//gKo̎ԍ
		if(strncmp(argv[cnum],"-d",2) == 0)sscanf(argv[cnum]+2,"%d",&delta_org);
	}

	//gKxF}10vXP[Őݒ肳ꂽx}512XP[ɕϊ
	T_Level = (signed int)(trg_level/10.0*(float)AD_SCALE);
	if(T_Level > AD_SCALE)T_Level = AD_SCALE;
	if(T_Level < -AD_SCALE)T_Level = -AD_SCALE;
	//ItZbgxF}10vXP[Őݒ肳ꂽx}512XP[ɕϊ
	O_Level = (signed int)(offset_level/10.0*AD_SCALE);
	if(O_Level > AD_SCALE)O_Level = AD_SCALE;
	if(O_Level < -AD_SCALE)O_Level = -AD_SCALE;
	//cdxF}10Vf[^ɑ΂䗦Őݒ
	Gain = v_gain/10.0;

	//̃sNZf[^Ȃ
	//̉𑜓xTvOf[^ɍ킹LINE`ɂČʓIɕԂČ`ɂȂ
	//tɉ̃sNZf[^
	//̃^CXP[̕\=TvONbN
	//ƓӂłƉ߂āAIWiTvOf[^Ԉωĕ`f[^
	time_x = time_us * s_clk * 10;
	if(PixNum_X >= time_x){
		pix_x = time_x;
		avg_num = 1;
	}else{
		pix_x = PixNum_X;
		//ől1000000*2*10/1000=20000
		avg_num = time_x / PixNum_X;
	}

	//gK|WV}5.0ňʒuݒ肳ꂽ̂PixNum_X̃XP[ɒ
	T_Pos	= (signed int)(((trg_pos+5.0)/10.0)*(float)pix_x);
	if(T_Pos > pix_x)T_Pos = pix_x;
	if(T_Pos < 0)T_Pos = 0;

	//ʂɃItZbgAgKʒux\ׂ̍W
	t_l = (trg_level+offset_level)/v_gain;
	o_l = offset_level/v_gain;
	t_p = trg_pos/5.0;

	//ݒe̕\
	printf("RaspberryPI_Oscilloscope_Start\n");
	if(s_cnum == 0){
		printf("SCLK     = 2MHz\n");//ftHgl
	}else{
		printf("SCLK     = %s\n",argv[s_cnum]+2);
	}
	sampling = (s_clk*1000)/avg_num;
	if(sampling >= 1000){
		printf("S/s      = %dMHz\n",sampling/1000);
	}else{
		printf("S/s      = %dkHz\n",sampling);
	}
	if(time_cnum == 0){
		printf("Time/div = 100us\n");//ftHgl
	}else{
		printf("Time/div = %s\n",argv[time_cnum]+2);
	}
	if(v_cnum == 0){
		printf("V/div    = 2v\n");//ftHgl
	}else{
		printf("V/div    = %s\n",argv[v_cnum]+2);
	}
	printf("offset   = %.2fv\n",offset_level);
	printf("trgedge  = %d\n",trg_e);
	printf("trglevel = %.2fv\n",trg_level);
	printf("trgpos   = %.1f\n",trg_pos);
//	printf("trgdelta = %dsck\n",delta_org);
//	printf("avg_num  = %d\n",avg_num);
	printf("pix_x    = %d\n",pix_x);



	VertexType lObj[] = {			//LINEf[^iwigj
		{.x = 1.0f*X_SCALE,	.y = 0.75f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -1.0f*X_SCALE,.y = 0.75f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//0,1
		{.x = -1.0f*X_SCALE,.y = 0.5f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = 1.0f*X_SCALE,	.y = 0.5f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//2,3
		{.x = 1.0f*X_SCALE,	.y = 0.25f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -1.0f*X_SCALE,.y = 0.25f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//4,5
		{.x = -1.0f*X_SCALE,.y = 0.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.8f},	{.x = 1.0f*X_SCALE,	.y = 0.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.8f},//6,7-S
		{.x = 1.0f*X_SCALE,	.y = -0.25f*Y_SCALE,.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -1.0f*X_SCALE,.y = -0.25f*Y_SCALE,.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//8,9
		{.x = -1.0f*X_SCALE,.y = -0.5f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = 1.0f*X_SCALE,	.y = -0.5f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//10,11
		{.x = 1.0f*X_SCALE,	.y = -0.75f*Y_SCALE,.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -1.0f*X_SCALE,.y = -0.75f*Y_SCALE,.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//12,13
		{.x = -1.0f*X_SCALE,.y = o_l*Y_SCALE,	.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//ItZbgZ^[14
		{.x = -1.04f*X_SCALE,.y = (o_l-0.04)*Y_SCALE,.z = 0.0f,	.u = 4.0f,	.v = 4.0f},//ItZbg15
		{.x = -1.04f*X_SCALE,.y = (o_l+0.04)*Y_SCALE,.z = 0.0f,	.u = 4.0f,	.v = 4.0f},//ItZbg16
		{.x = -1.0f*X_SCALE,.y = o_l*Y_SCALE,		.z = 0.0f,	.u = 4.0f,	.v = 4.0f},//ItZbgZ^[17
		{.x = -1.0f*X_SCALE,.y = t_l*Y_SCALE,		.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//gKxZ^[18
		{.x = -1.03f*X_SCALE,.y = (t_l-0.03)*Y_SCALE,.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//gKx19
		{.x = -1.03f*X_SCALE,.y = (t_l+0.03)*Y_SCALE,.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//gKx20
		{.x = -1.0f*X_SCALE,.y = t_l*Y_SCALE,		.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//gKxZ^[21
		{.x = -1.0f*X_SCALE,.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//22
		{.x = 0.8f*X_SCALE,	.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = 0.8f*X_SCALE,	.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c23,24
		{.x = 0.6f*X_SCALE,	.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = 0.6f*X_SCALE,	.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c25,26
		{.x = 0.4f*X_SCALE,	.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = 0.4f*X_SCALE,	.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c27,28
		{.x = 0.2f*X_SCALE,	.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = 0.2f*X_SCALE,	.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c29,30
		{.x = 0.0f*X_SCALE,	.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.8f},	{.x = 0.0f*X_SCALE,	.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.8f},//c31,32-S
		{.x = -0.2f*X_SCALE,.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -0.2f*X_SCALE,.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c33,34
		{.x = -0.4f*X_SCALE,.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -0.4f*X_SCALE,.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c35,36
		{.x = -0.6f*X_SCALE,.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -0.6f*X_SCALE,.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c37,38
		{.x = -0.8f*X_SCALE,.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},	{.x = -0.8f*X_SCALE,.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//c39,40
		{.x = -1.0f*X_SCALE,.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//45
		{.x = 1.0f*X_SCALE,	.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//E46
		{.x = 1.0f*X_SCALE,	.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//E47
		{.x = -1.0f*X_SCALE,.y = -1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//48
		{.x = -1.0f*X_SCALE,.y = 1.0f*Y_SCALE,	.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//49
		{.x = t_p*X_SCALE,	.y = 1.0f*Y_SCALE,		.z = 0.0f,	.u = 0.0f,	.v = 0.0f},//gK|WVZ^[41
		{.x = (t_p-0.02)*X_SCALE,.y = 1.03f*Y_SCALE,.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//gK|WV42
		{.x = (t_p+0.02)*X_SCALE,.y = 1.03f*Y_SCALE,.z = 0.0f,	.u = 4.0f,	.v = 0.0f},//gK|WVE43
		{.x = t_p*X_SCALE,	.y = 1.0f*Y_SCALE,		.z = 0.0f,	.u = 4.0f,	.v = 0.0f}//gK|WVZ^[44
	};

	//`pobt@̏
	for(idx = 0;idx < pix_x;idx++){//g`\p
		vObj[idx].x = ((float)idx/(float)(pix_x/2) - 1.0)*X_SCALE;
		vObj[idx].y = 0.0;
		vObj[idx].z = 0.1;
		vObj[idx].u = 1.0;
		vObj[idx].v = 1.0;
		ivObj[idx]=idx;//CfbNXԍݒ
	}
	for(idx = 0;idx < LinePoint;idx++){//C\p
		ilObj[idx]=idx;//CfbNXԍݒ
	}

	//XbhŎgp鋤pϐ̏
	area = 0;

	bcm_host_init();
	res = WinCreate(&g_sc);
	if (!res) return 0;
	res = SurfaceCreate(&g_sc);
	if (!res) return 0;
	res = InitShaders(&g_program, vShaderSrc, fShaderSrc);
	if (!res) return 0;

	// _f[^̓]
	createBuffer();

	// VF[_̕ϐԍL^
	g_sp.aPosition = glGetAttribLocation(g_program, "aPosition");
	g_sp.aTex = glGetAttribLocation(g_program, "aTex");
	g_sp.uFrame  = glGetUniformLocation(g_program, "uFrame");

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);// ʏ̐F
	glUniform1f(g_sp.uFrame, 0.0);	// jtH[ϐɒ_ʒũItZbgݒ

	pthread_t tid1, tid2; // Xbhʕϐ
	pthread_mutex_init(&mutex, NULL);//2̃XbhԂŕϐ̕یs
	// Xbh̍쐬
	pthread_create(&tid1, NULL, thread1, NULL);
	pthread_create(&tid2, NULL, thread2, NULL);


	//60fps
	while(1){
		//ȉ4ߕ̎s1.2ms
		//g`p
		glBindBuffer(GL_ARRAY_BUFFER, g_vbo);								//obt@̎ނݒ
		glBufferData(GL_ARRAY_BUFFER, sizeof(vObj), vObj, GL_STATIC_DRAW);	//GPUɓ]
		//gp
		glBindBuffer(GL_ARRAY_BUFFER, g_lbo);								//obt@̎ނݒ
		glBufferData(GL_ARRAY_BUFFER, sizeof(lObj), lObj, GL_STATIC_DRAW);	//GPUɓ]

		//ȉ2ߕ̎s6us
		glViewport(0, 0, g_sc.width, g_sc.height);			//
		glClear(GL_COLOR_BUFFER_BIT);						// ʏ

		//̊֐Ԃ34us
//		digitalWrite(chksig4, 1);
		Draw();												// `
//		digitalWrite(chksig4, 0);

		//LsŃTCNt[XVTCN1/60i16.666msjɂȂ悤ɒił15.36msj
//		digitalWrite(chksig5, 1);
		view_act = 1;
		eglSwapBuffers(g_sc.display, g_sc.surface);			// \
		view_act = 0;
//		digitalWrite(chksig5, 0);
	}

	// XbhI҂
	pthread_join(tid1,NULL);
	pthread_join(tid2,NULL);

	pthread_mutex_destroy(&mutex);
	return 0;
}


//Xbh1

void* thread1(void* pParam)
{
	int k,l,m;
	int buf_offset = 0;
	int buf_pos = 0;
	int buf_pos_a = 0;
	int buf_pos_b = 0;
	int swap_next = 0;
	int trg_next = 0;
	int swap_area = 0;
	int buf_area = 0;
	int data_pos = 0;
	int data_count = 0;
	int go_swap = 0;
	int go_trgchk = 0;
	int chk_area = 0;
	signed short swap_buf,down_buf;
	signed short buf_max = -AD_SCALE;
	signed short buf_min = AD_SCALE;
	int nontrg_count = 0;
	int view_flg = 0;
	int swap_flg = 0;
	int avg_count = 0;
	int buffvol;
	int buffvol_all;
//	float div;
//	signed long avg_buf = 0;
	int delta_a,delta_b;

	signed short dat_buf[DataNum*3];
	signed short view_buf[PixNum_X];


	//ω񐔂違obt@ʂƕ\XVxȂ̂
	//ݒ󋵂ɍ킹ēKxɃobt@ʂ炷
	if((avg_num * s_clk) >= 10){
		buffvol = 1024;
	}else{
		buffvol = DataNum;
	}
	buffvol_all = buffvol*3;

	//gKGbWI
	if(trg_e == 1){		//オ菈
		delta_a = 0;
		delta_b = delta_org;
	}else{				//菈
		delta_a = delta_org;
		delta_b = 0;
	}

	while(1){
		//Oobt@i[菇߂
		if((swap_next == 0)&&(area == 0)){
			swap_area = 2;
			go_swap = 1;
		}
		if((swap_next == 1)&&(area == 1)){
			swap_area = 0;
			go_swap = 1;
		}
		if((swap_next == 2)&&(area == 2)){
			swap_area = 1;
			go_swap = 1;
		}

		//USBobt@珈pOobt@֊i[
		if(go_swap == 1){
//			digitalWrite(chksig1, 1);//`FbNp

			//gKô܂1bo߂Af[^̂܂ܕ\
			//2MHz̏ꍇ500ns̃TvOf[^DataNum(4096)Ȃ̂Ŏ擾TCN͖2ms
			//1MHz̏ꍇ1us̃TvOf[^DataNum(4096)Ȃ̂Ŏ擾TCN͖4ms
			//̏USB̃f[^XVɓčsĂ̂ł𗘗păJEgĂ
			nontrg_count++;

			//ԂɃOobt@ׂ̐ݒ
			go_swap = 0;
			if(swap_area == 2)swap_next = 1;
			if(swap_area == 0)swap_next = 2;
			if(swap_area == 1)swap_next = 0;

			//A/D10bitf[^ItZbgoCi0x0200𕄍t16bitWORD`ɕϊăOobt@ɓ
			//^CXP[ꍇ̏iGbWoorωj
			for(k = 0;k < DataNum;k++){
				swap_buf = (buf[swap_area][k*2]&0x00ff)|((buf[swap_area][k*2+1]<<8)&0x0300);
				swap_buf = swap_buf - 0x0200;
				if(avg_num == 1){	//ʏ폈
					data_pos = (swap_area * DataNum) + k;
					dat_buf[data_pos] = (signed short)swap_buf;
				}else{				//Tv[gቺ
					if(swap_buf > buf_max){//s[No
						buf_max = swap_buf;	//ől
					}
					if(swap_buf < buf_min){//s[No
						buf_min = swap_buf;	//ŏl
					}
//					avg_buf = avg_buf + swap_buf;//ςꍇ̗ݐ
					avg_count++;
					if(avg_num == avg_count){
						if((trg_e == 1)&&(buf_max >= T_Level)&&(buf_min < T_Level)){
							down_buf = buf_max;
						}else if((trg_e == 0)&&(buf_min < T_Level)&&(buf_max >= T_Level)){
							down_buf = buf_min;
						}else{
//							div = (float)avg_buf/(float)avg_num;//ϒl
							if(data_count%2 == 0 ){
								down_buf = buf_max;
							}else{
								down_buf = buf_min;
							}
						}
						dat_buf[data_pos] = down_buf;//mCỸs[N\g``
//						dat_buf[data_pos] = (signed short)div;//tB^gg``
						data_pos = data_count;
//						avg_buf = 0;
						avg_count = 0;
						buf_max = -AD_SCALE;
						buf_min = AD_SCALE;
						data_count++;
						if(data_count == buffvol_all)data_count = 0;
					}
				}
			}
			if(data_pos < buffvol){
				buf_area = 0;
			}else if(data_pos < (buffvol*2)){
				buf_area = 1;
			}else {
				buf_area = 2;
			}
			//gKoGA߂
			if((trg_next == 0)&&(buf_area == 0)){
				chk_area = 1;
				go_trgchk = 1;
			}
			if((trg_next == 1)&&(buf_area == 1)){
				chk_area = 2;
				go_trgchk = 1;
			}
			if((trg_next == 2)&&(buf_area == 2)){
				chk_area = 0;
				go_trgchk = 1;
			}
//			digitalWrite(chksig1, 0);
		}

		//Oobt@gKos
		if(go_trgchk == 1){
//			digitalWrite(chksig2, 1);
			//USB̃f[^XVĂGAȂgKs菇߂
			go_trgchk = 0;
			if(chk_area == 0)trg_next = 0;
			if(chk_area == 1)trg_next = 1;
			if(chk_area == 2)trg_next = 2;

			//`FbNsȂobt@̃ItZbgʒu
			buf_offset = chk_area * buffvol;

			//gK
			for(l = T_Pos;l < (buffvol + T_Pos);l++){
				buf_pos_a =buf_offset + l - delta_a;
				buf_pos_b =buf_offset + l - delta_b;
				if(buf_pos_a < 0)			buf_pos_a = buffvol_all + buf_pos_a;
				if(buf_pos_a >= buffvol_all)	buf_pos_a = buf_pos_a - buffvol_all;
				if(buf_pos_b < 0)			buf_pos_b = buffvol_all + buf_pos_b;
				if(buf_pos_b >= buffvol_all)	buf_pos_b = buf_pos_b - buffvol_all;
				if((dat_buf[buf_pos_a] >= T_Level)&&(dat_buf[buf_pos_b] < T_Level)){
					nontrg_count = 0;
					for(m = 0;m < pix_x;m++){
						buf_pos = buf_offset + l - T_Pos + m;
						if(buf_pos < 0)			buf_pos = buffvol_all + buf_pos;
						if(buf_pos >= buffvol_all)buf_pos = buf_pos - buffvol_all;
						view_buf[m] = dat_buf[buf_pos];
					}
					l = l + (pix_x - T_Pos);//̌oGA͊ɕ`悵GAOi`~ςꍇɈӖj
					if(l >= (buffvol + T_Pos))break;
				}
			}
			//gKȍ
			if(nontrg_count > (250*s_clk)){//gK1bȏ
				nontrg_count = (250*s_clk);
				for(m = 0;m < pix_x;m++){
					view_buf[m] = dat_buf[buf_offset + m];//`f[^͓K
				}
			}
//			digitalWrite(chksig2, 0);
		}

		//Open-GL1/60̕`揈Ă^C~Oo
		if(view_act == 0){
			view_flg = 1;
		}
		if((view_flg == 1)&&(view_act == 1)){
			view_flg = 0;
			swap_flg = 1;
		}
		//Open-GL̃t[obt@Ɉn
		//Open-GL`揈iϐQƂĂȂ^C~OjɑĂ
		if((view_act == 1)&&(swap_flg == 1)){
//			digitalWrite(chksig3, 1);
			for(m = 0;m < pix_x;m++){
				vObj[m].y = (float)(view_buf[m] + O_Level)/(AD_SCALE * Gain)*Y_SCALE;
			}
			view_act = 0;
//			digitalWrite(chksig3, 0);
		}

	}
}

//Xbh2
void* thread2(void* pParam)
{
	struct usb_bus *bus;
	struct usb_device *dev;
	usb_dev_handle *dh;
	int ret;

	//
	bus=USB_init();
	dev=USB_find(bus,dev);
	if( dev==NULL ){ exit(1); }
	dh=USB_open(dev);
	if( dh==NULL ){ exit(1); }
	USB_altinterface(dh,1);
	//FX2-8051̃ZbgԂ
	ret = usb_control_msg(dh,0x40,0xa0,0xe600,0,"\0",1,TIMEOUT);
	if(ret<0){ exit(1); }

	while(1){

//		digitalWrite(chksig0, 1);//`FbNpo
		//USBf[^擾
		ret = usb_bulk_read(dh,EP6, buf[area], FByte, TIMEOUT);
//		digitalWrite(chksig0, 0);//`FbNo͂OFF

		if(ret<0){
			fprintf(stderr,"usb_error.(%s)\n",usb_strerror());
			break;
		}

		//Oobt@̏ꏊ̎w
		area++;
		if(area >= 3)area = 0;
	}

	USB_close(dh);
	printf("USB End\n");
}
